"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.unlinkInlineSmartLinkTestCase = void 0;
var _inProductTesting = require("@atlaskit/in-product-testing");
var _inProduct = require("@atlaskit/smart-card/in-product");
var _Editor = require("../../../../page-objects/Editor");
var _EditorSmartLink = require("../../../../page-objects/EditorSmartLink");
var unlinkInlineSmartLinkTestCase = exports.unlinkInlineSmartLinkTestCase = function unlinkInlineSmartLinkTestCase(_ref) {
  var ui = _ref.ui,
    url = _ref.url;
  return new _inProductTesting.InProductTestCase({
    title: 'unlinking an Inline Smart Link works',
    id: 'inline-smart-link-unlink',
    assertions: function assertions(cy) {
      var editor = new _Editor.EditorPageObject(cy);
      var editorWithSmartLinks = new _EditorSmartLink.EditorSmartLinkPageObject(cy, editor);
      var inlineCard = new _inProduct.InlineCardPageObject(cy);
      editorWithSmartLinks.insertSmartLinkByTyping(url);
      (0, _inProduct.inlineSmartLinkRendersTestCase)({
        url: url
      }).assertions(cy);
      editorWithSmartLinks.unlink();
      inlineCard.expectCardNotExists();
      inlineCard.assertHrefNotRendered(url);
      if (ui !== null && ui !== void 0 && ui.publishButton) {
        var renderer = editor.publish(ui);
        renderer.expectContentReady();
        inlineCard.expectCardNotExists();
        inlineCard.assertHrefNotRendered(url);
      }
    }
  });
};