"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.sendMBEAnalyticsEvent = void 0;
var _analytics = require("../../analytics");
var _eventDispatcher = require("../../event-dispatcher");
var _utils = require("../../utils");
var sendMBEAnalyticsEvent = exports.sendMBEAnalyticsEvent = function sendMBEAnalyticsEvent(action, node, eventDispatcher) {
  var analyticsDispatch = (0, _eventDispatcher.createDispatch)(eventDispatcher);
  analyticsDispatch(_utils.analyticsEventKey, {
    payload: {
      action: action,
      actionSubject: _analytics.ACTION_SUBJECT.MULTI_BODIED_EXTENSION,
      eventType: _analytics.EVENT_TYPE.TRACK,
      attributes: {
        extensionType: node.attrs.extensionType,
        extensionKey: node.attrs.extensionKey,
        localId: node.attrs.localId,
        currentFramesCount: node.content.childCount
      }
    }
  });
};