"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.md = void 0;
var _markdownIt = _interopRequireDefault(require("markdown-it"));
var _ignoreListHeadingMdPlugin = _interopRequireDefault(require("./md-plugins/ignore-list-heading-md-plugin"));
var _linkifyMdPlugin = _interopRequireDefault(require("./md-plugins/linkify-md-plugin"));
var _newlineMdPlugin = _interopRequireDefault(require("./md-plugins/newline-md-plugin"));
var _paragraphMdPlugin = _interopRequireDefault(require("./md-plugins/paragraph-md-plugin"));
// File has been copied to packages/editor/editor-plugin-ai/src/provider/markdown-transformer/md/index.ts
// If changes are made to this file, please make the same update in the linked file.

var md = exports.md = (0, _markdownIt.default)('zero', {
  html: false
});
md.enable([
// Process html entity - &#123;, &#xAF;, &quot;, ...
'entity',
// Process escaped chars and hardbreaks
'escape', 'newline']);
md.use(_paragraphMdPlugin.default);

// enable modified version of linkify plugin
// @see https://product-fabric.atlassian.net/browse/ED-3097
md.use(_linkifyMdPlugin.default);
md.use(_newlineMdPlugin.default);
md.use(_ignoreListHeadingMdPlugin.default);