import type { Node as PMNode } from '@atlaskit/editor-prosemirror/model';
import type { GuidelineConfig, GuidelineTypes, Position, Range, VerticalPosition } from './types';
export declare const isNumber: (x: unknown) => x is number;
export declare const isRange: (range: unknown) => range is Range;
export declare const isVerticalPosition: (pos: Position) => pos is VerticalPosition;
/**
 * Returns the type of guideline based on a guideline key and a collection of guidelines
 */
export declare const getGuidelineTypeFromKey: (keys: string[], guidelines: GuidelineConfig[]) => GuidelineTypes;
/**
 * Calculates container or full editor width taking in account editor full width layout
 * width and editor gutter padding.
 */
export declare const getContainerWidthOrFullEditorWidth: (containerWidth: number) => number;
/**
 *
 * @param mediaSingle the mediaSingle node
 * @param editorWidth default 760, only use default if the mediaSingle is using pixel width
 * @returns null or dimensions info
 */
export declare const getMediaSingleDimensions: (mediaSingle: PMNode, editorWidth?: number) => {
    width: number;
    height: number;
    originalWidth: number;
    originalHeight: number;
    ratio: number;
} | null;
