/**
 * Allow to run methods from the given provider interface across all providers seamlessly.
 * Handles promise racing and discards rejected promises safely.
 */
declare const _default: <P>(providers: (P | Promise<P>)[]) => {
    invokeSingle: <T>(methodName: keyof P, args?: any[]) => Promise<T>;
    invokeList: <T_1>(methodName: keyof P, args?: any[]) => Promise<T_1[]>;
};
export default _default;
