import React, { PureComponent } from 'react';
import { jsx } from '@emotion/react';
import type { MenuItem, Props, State } from './types';
export type { MenuItem } from './types';
/**
 * Wrapper around @atlaskit/droplist which uses Popup and Portal to render
 * dropdown-menu outside of "overflow: hidden" containers when needed.
 *
 * Also it controls popper's placement.
 */
export default class DropdownMenuWrapper extends PureComponent<Props, State> {
    state: State;
    private popupRef;
    private handleRef;
    private updatePopupPlacement;
    private handleCloseAndFocus;
    private handleClose;
    private renderDropdownMenu;
    render(): jsx.JSX.Element;
    componentDidUpdate(previousProps: Props): void;
}
export declare function DropdownMenuItem({ item, onItemActivated, shouldUseDefaultRole, onMouseEnter, onMouseLeave, }: {
    item: MenuItem;
} & Pick<Props, 'onItemActivated' | 'shouldUseDefaultRole' | 'onMouseEnter' | 'onMouseLeave'>): jsx.JSX.Element;
export declare const DropdownMenuWithKeyboardNavigation: React.MemoExoticComponent<({ ...props }: React.PropsWithChildren<any>) => jsx.JSX.Element>;
