import { EDITOR_APPEARANCE_CONTEXT } from '@atlaskit/analytics-namespaced-context';
import { ACTION, ACTION_SUBJECT, ACTION_SUBJECT_ID, EVENT_TYPE } from '../analytics';
export declare const getAnalyticsAppearance: (appearance?: string) => EDITOR_APPEARANCE_CONTEXT | undefined;
export declare const getAnalyticsEditorAppearance: (editorAppearance?: string) => string;
export declare const getAnalyticsEventSeverity: (duration: number, normalThreshold: number, degradedThreshold: number) => SEVERITY;
export declare enum SEVERITY {
    NORMAL = "normal",
    DEGRADED = "degraded",
    BLOCKING = "blocking"
}
export { UNSUPPORTED_CONTENT_LEVEL_SEVERITY, getUnsupportedContentLevelData, UNSUPPORTED_CONTENT_LEVEL_SEVERITY_THRESHOLD_DEFAULTS, } from './unsupportedContent/get-unsupported-content-level-data';
export type { UnsupportedContentLevelsTracking } from './unsupportedContent/get-unsupported-content-level-data';
type AEP<Action, ActionSubject, ActionSubjectID, Attributes, EventType> = {
    action: Action;
    actionSubject: ActionSubject;
    actionSubjectId?: ActionSubjectID;
    attributes?: Attributes;
    eventType: EventType;
};
type TrackAEP<Action, ActionSubject, ActionSubjectID, Attributes> = AEP<Action, ActionSubject, ActionSubjectID, Attributes, EVENT_TYPE.TRACK>;
type UnsupportedContentEncounteredAEP = TrackAEP<ACTION.UNSUPPORTED_CONTENT_ENCOUNTERED, ACTION_SUBJECT.DOCUMENT, ACTION_SUBJECT_ID, {
    unsupportedNode: Record<string, any>;
    errorCode?: String;
}>;
export type UnsupportedContentPayload = UnsupportedContentEncounteredAEP;
export type UnsupportedContentTooltipPayload = AEP<ACTION.UNSUPPORTED_TOOLTIP_VIEWED, ACTION_SUBJECT.TOOLTIP, ACTION_SUBJECT_ID.ON_UNSUPPORTED_BLOCK | ACTION_SUBJECT_ID.ON_UNSUPPORTED_INLINE, {
    unsupportedNodeType: string | undefined;
}, EVENT_TYPE.UI>;
export declare const analyticsEventKey = "EDITOR_ANALYTICS_EVENT";
