import { PropsDifference, ShallowPropsDifference } from '../../../compare-props';
type PropsDiff<Props> = ShallowPropsDifference<Props> | PropsDifference<Props>;
type OnRenderCb<Props = undefined> = ({ renderCount, propsDifference, }: {
    renderCount: number;
    propsDifference: PropsDiff<Props> | undefined;
    componentId: string;
}) => void;
export type UseComponentRenderTrackingArgs<Props = undefined> = {
    onRender: OnRenderCb<Props>;
    propsDiffingOptions?: {
        enabled: boolean;
        props?: Props;
        propsToIgnore?: Array<keyof Props>;
        useShallow?: boolean;
    };
    zeroBasedCount?: boolean;
};
export declare function useComponentRenderTracking<Props = undefined>({ onRender, propsDiffingOptions, zeroBasedCount, }: UseComponentRenderTrackingArgs<Props>): void;
export {};
